#if !defined(VIEW_H)
#define VIEW_H


#include <string>
#include <vector>

#include <hsm/core/Component.h>

class CompositeView;

namespace hsm {
	class SVGLWindow;
} // namsepace hsm
 
namespace svg {
	class SVGGElement;
	class SVGRectElement;
	class SVGTextElement;
	class SVGUseElement;
} // namespace svg



class View : public hsm::impl::Component< > {
	friend class CompositeView;
	
protected :
	hsm::SVGLWindow *window;

	CompositeView *parent;	
	
	svg::SVGGElement *view;
	svg::SVGRectElement *viewBg;
	svg::SVGTextElement *name;
	svg::SVGGElement *content;
	svg::SVGRectElement *contentBg;
	svg::SVGUseElement *resize;
	
	float width, height;
	float mx, my;
	
	
public :
	View(const std::string &label, hsm::SVGLWindow *w, CompositeView *p = 0);
	virtual ~View();

	void maximize();
	void minimize();
	
	void resetGeometry();
	virtual void setGeometry(float x, float y, float w, float h);

	virtual void process(const hsm::Event &event);
};

class CompositeView : public View {
protected :
	svg::SVGGElement *list;
	svg::SVGRectElement *listBg;
	
	std::vector< View * > views;
	
public :
	CompositeView(const std::string &label, hsm::SVGLWindow *w, CompositeView *p = 0);

	virtual void setGeometry(float x, float y, float w, float h);
	void insert(View *child, unsigned int position = 0);
};


#endif // !defined(VIEW_H)
