#include <w3c/svg/SVGDocument.hpp>
#include <w3c/svg/SVGElement.hpp>
#include <w3c/svg/SVGRectElement.hpp>
#include <w3c/svg/SVGCircleElement.hpp>

#include <hsm/interaction/Protocol.h>
#include <hsm/svgl/SVGLBehaviour.h>
#include <hsm/util/Debug.h>

#include <hsm/svgl/SVGLWindow.h>

#include <hsm/svgl/Svgl.h>



class Column : public hsm::SVGLBehaviour, public hsm::EnterLeave, public hsm::PressRelease {
	static const hsm::SVGLBehaviour::Factory::Register< Column > registration;
	
	svg::SVGRectElement *rect;
	unsigned int id;

public :
	Column(svg::SVGElement *e, hsm::SVGLWindow *w) : hsm::SVGLBehaviour(e, w) {
		hsm::svgl::getAttribute(e, "hsm-arg:id", id);
		rect = dynamic_cast< svg::SVGRectElement * >(elem);
	}
	
	
	virtual void enter() {
		rect->setStrokeOpacity(1);
	}
	
	virtual void leave() {
		rect->setStrokeOpacity(0);
	}

	
	virtual void press() {
		window->lock();
		svg::SVGCircleElement *coin = new svg::SVGCircleElement(window->svgDocument);
		hsm::svgl::setAttribute(coin, "hsm:behaviour", "coin");
		hsm::svgl::setAttribute(coin, "hsm-arg:col", id);
		hsm::svgl::setAttribute(coin, "hsm-arg:row", 0);
		window->svgContent->appendChild(coin);
		window->instanciateBehaviour(coin);
		window->unlock();
	}
	
	virtual void release() {}
};

const hsm::SVGLBehaviour::Factory::Register< Column > Column::registration("column");
