////////////////////////////////////////////////////////////////////////////////
// File    : Trans2zoom.cpp
// Content : a class to demonstrate how to implement interaction behaviour
// History : 11-Feb-2004 - [rb] creation
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2004  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* includes *******************************************************************/

#include <Trans2zoom.h>
#include <hsm/svgl/SVGLWindow.h>
#include <hsm/svgl/SVGLWindowPicking.h>


/* Trans2zoom interaction definition ******************************************/

const hsm::SVGLBehaviour::Factory::Register< Trans2zoom > Trans2zoom::registration("trans2zoom");


Trans2zoom::Trans2zoom(svg::SVGElement *e, hsm::SVGLWindow *w) : hsm::SVGLBehaviour(e, w), zoom(0) {}

bool Trans2zoom::begin() {
	hsm::Point sp(2);
	window->window2screen(pick, sp);
	zoom = window->pick< hsm::Zoom >(sp, elem);
	if(zoom != 0) {
		return zoom->begin();
	}
	return false;
}

void Trans2zoom::end() {
	if(zoom != 0) {
		zoom->end();
	}
}

void Trans2zoom::translate(const hsm::Point &p) {
	if(zoom != 0) zoom->zoom(p/hsm::Point::X - p/hsm::Point::Y);
}
