////////////////////////////////////////////////////////////////////////////////
// File    : Trans2zoom.h
// Content : a class to demonstrate how to implement interaction behaviour
// History : 11-Feb-2004 - [rb] creation
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2004  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#if !defined(TRANS2ZOOM_H)
#define TRANS2ZOOM_H


/* includes *******************************************************************/

#include <hsm/svgl/SVGLBehaviour.h>


/* Trans2zoom interaction definition ******************************************/

class Trans2zoom : public hsm::SVGLBehaviour, public hsm::Translate {
private :
	static const hsm::SVGLBehaviour::Factory::Register< Trans2zoom > registration;
	hsm::Zoom *zoom;
	
public :
	Trans2zoom(svg::SVGElement *e, hsm::SVGLWindow *w);

	virtual bool begin();
	virtual void end();
	
	virtual void translate(const hsm::Point &p);
};


#endif // !defined(TRANS2ZOOM_H)
