////////////////////////////////////////////////////////////////////////////////
// File    : ThreadLoop.MACOSX.cpp
// Content : a thread based classes
// History : 
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2004  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



/* includes *******************************************************************/

#include <ThreadLoop.h>


namespace hsm {

/* ThreadLoop::os struct implementation ***************************************/

	void *ThreadLoop::os::threadFn(void *tl) {
		ThreadLoop *threadLoop = reinterpret_cast< ThreadLoop * >(tl);
		threadLoop->loop();
		return 0;
	}

	ThreadLoop::os::Id ThreadLoop::os::create(ThreadLoop *tl) {
		Id id;
		pthread_create(&id, 0, threadFn, (void *)(tl));
		return id;
	}

	void ThreadLoop::os::waitFor(Id id) {
		pthread_join(id, 0);
	}

	ThreadLoop::os::Id ThreadLoop::os::self() {
		return pthread_self();
	}


} // namespace hsm
