////////////////////////////////////////////////////////////////////////////////
// File    : EnterLeavable.h
// Content : enter leave highlite for svgl objects
// History : 16-Feb-2004 - [rb] creation
////////////////////////////////////////////////////////////////////////////////

/*
 Copyright (C) 2004  Renaud Blanch <rb.hsm@laposte.net>
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#if !defined(HSM_ENTERLEAVABLE_H)
#define HSM_ENTERLEAVABLE_H


/* includes *******************************************************************/

#include <hsm/svgl/SVGLBehaviour.h>


namespace hsm {

/* EnterLeavable class declaration ********************************************/

	class EnterLeavable : public SVGLEnterLeave {
	private :
		static const SVGLBehaviour::Factory::Register< EnterLeavable > registration;

	public :
		EnterLeavable(svg::SVGElement *e, SVGLWindow *w) : SVGLBehaviour(e, w), SVGLEnterLeave(e, w) {}
	};
	

} // namespace hsm


#endif // !defined(HSM_ENTERLEAVABLE_H)
